--
-- Speedo km/h
-- This is supposed to change mp/h to km/h
-- Version 0.5
-- Author Knuuud
-- Date: 09/06/2011
--

Units = {};

-- Extended original function --
function Units.draw(self, dt)
  
      local kmh = math.min(100, math.max(0, self.lastSpeed*self.speedDisplayScale*3600));
  
      self.hudBackgroundOverlay:render();
  
      setTextBold(true);
  
      setTextColor(1.0, 1.0, 1.0, 1.0);
      setTextAlignment(RenderText.ALIGN_CENTER);
  
      local maxSpeed = 80;
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005 + 3 * 0.0396, 0.024, string.format("%2d " .. g_i18n:getText("speedometer"), kmh));
      setTextColor(1, 1, 1, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008 + 3 * 0.0396, 0.024, string.format("%2d " .. g_i18n:getText("speedometer"), kmh));
  
      self.hudBarRedOverlay.width = self.hudBarWidth * math.min(1, kmh / maxSpeed);
      setOverlayUVs(self.hudBarRedOverlay.overlayId, 0, 0.05, 0, 1, math.min(1, kmh / maxSpeed), 0.05, math.min(1, kmh / maxSpeed), 1);
      self.hudBarRedOverlay:render();
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005 + 2 * 0.0396, 0.024, string.format("%1.0f " .. g_i18n:getText("Currency_symbol"), g_currentMission.missionStats.money));
      setTextColor(1, 1, 1, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008 + 2 * 0.0396, 0.024, string.format("%1.0f " .. g_i18n:getText("Currency_symbol"), g_currentMission.missionStats.money));
  
      local currentFuelPercentage = 0;
      local fuelWarnPercentage = 20;
      if self.fuelCapacity > 0 then
          currentFuelPercentage = (self.fuelFillLevel / self.fuelCapacity + 0.0001) * 100;
      end;
  
      setTextColor(0, 0, 0, 1);
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.005, 0.024, string.format("%d " .. g_i18n:getText("fluid_unit_long"), self.fuelFillLevel));
      if currentFuelPercentage < fuelWarnPercentage then
          setTextColor(1, 0, 0, 1);
      else
          setTextColor(1, 1, 1, 1);
      end;
      renderText(self.hudBasePosX + self.hudBaseWidth / 2 + 0.002, self.hudBasePosY + 0.008, 0.024, string.format("%d " .. g_i18n:getText("fluid_unit_long"), self.fuelFillLevel));
  
      if currentFuelPercentage < fuelWarnPercentage then
          setTextColor(1, 1, 1, 1);
      end;
  
      self.hudBarGreenOverlay.width = self.hudBarWidth * (self.fuelFillLevel / self.fuelCapacity); -- TODO: check for division by zero!
      setOverlayUVs(self.hudBarGreenOverlay.overlayId, 0, 0.05, 0, 1, self.fuelFillLevel / self.fuelCapacity, 0.05, self.fuelFillLevel / self.fuelCapacity, 1);
      self.hudBarGreenOverlay:render();
  
      local trailerFillLevel, trailerCapacity = self:getAttachedTrailersFillLevelAndCapacity();
      if trailerFillLevel ~= nil and trailerCapacity ~= nil and trailerCapacity > 0 then
          self:drawGrainLevel(trailerFillLevel, trailerCapacity, 101);
      else
          -- if we don't have a trailer attached and we're not in a combine, render the frames overlay now
          if self.grainTankFillLevel == nil then
              self.hudFramesOverlay:render();
          end;
      end;
  
      setTextAlignment(RenderText.ALIGN_LEFT);
      setTextBold(false);
  
      if self.showWaterWarning then
          --g_currentMission:addWarning("Fahren Sie nicht zu tief ins Wasser", 0.05, 0.025+0.007);
          g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_depth_into_the_water"), 0.05, 0.025+0.007);
      end;
  
      if table.getn(self.attachedImplements) > 1 then
          --g_currentMission:addHelpButtonText("Ger?teauswahl wechseln", InputBinding.SWITCH_IMPLEMENT);
          g_currentMission:addHelpButtonText(g_i18n:getText("Change_tools"), InputBinding.SWITCH_IMPLEMENT);
      end;
  
      --local cam = self.cameras[self.camIndex];
      --if cam ~= nil then
      --    renderText(0.4,0.5,0.03,string.format("rot: %f trans: %f", cam.rotX, Utils.vector3Length(cam.transX, cam.transY, cam.transZ)));
      --end;
  
      if Vehicle.debugRendering then
          renderText(0.5, 0.10, 0.025, string.format(" real acc: %1.2f", self.lastRealAcceleration));
          renderText(0.5, 0.13, 0.025, string.format("      acc: %1.2f", self.lastAcceleration));
          renderText(0.5, 0.16, 0.025, string.format("motor rpm: %1.2f", self.motor.lastMotorRpm));
          renderText(0.5, 0.19, 0.025, string.format("wheel rpm: %1.2f", self.wheelRpm));
      end;
end;

-- Overwrite the original function --
Steerable.draw = Units.draw;